=== debian/changelog ===
plastimatch (1.5.11+dfsg0-1) unstable; urgency=low

  * new upstream release (Closes: #674373)
  * bump compat level to 9
  * remove Section: science
  * add full copyright information for included libraries

 -- Gregory C. Sharp <gregsharp.geo@yahoo.com>  Sat, 16 Jun 2012 12:25:19 -0400

plastimatch (1.5.10+dfsg0-1) unstable; urgency=low

  * build with libpng-dev instead of libpng12-dev (Closes: #662467)
  * add dependency on libdcmtk2-dev
  * new upstream release

 -- Gregory C. Sharp <gregsharp.geo@yahoo.com>  Fri, 13 Apr 2012 23:17:59 -0400
