=== debian/control ===
Source: plastimatch
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Gregory C. Sharp <gregsharp.geo@yahoo.com>, Dominique Belhachemi <domibel@debian.org>
Build-Depends: debhelper (>= 9), cmake,
  gfortran, 
  libdcmtk2-dev (>= 3.6.0-10), 
  libfftw3-dev, 
  libgdcm2-dev, 
  libinsighttoolkit3-dev (>= 3.20.0-15), 
  libpng-dev, 
  libtiff4-dev, 
  uuid-dev, 
  zlib1g-dev
Standards-Version: 3.9.3
Homepage: http://plastimatch.org
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/plastimatch/trunk/
Vcs-Browser: http://svn.debian.org/wsvn/debian-med/trunk/packages/plastimatch/trunk

Package: plastimatch
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: medical image reconstruction and registration
 Plastimatch is an open source software for deformable 
 image registration. It is designed for high-performance 
 volumetric registration of medical images, such as X-ray 
 computed tomography (CT), magnetic resonance imaging 
 (MRI), and positron emission tomography (PET). Software 
 features include:
    * B-spline method for deformable image registration 
      (GPU and multicore accelerated)
    * Demons method for deformable image registration 
      (GPU accelerated)
    * ITK-based algorithms for translation, rigid, affine, 
      demons, and B-spline registration
    * Pipelined, multi-stage registration framework with 
      seamless conversion between most algorithms and 
      transform types
    * Landmark-based deformable registration using thin-
      plate splines for global registration
    * Landmark-based deformable registration using radial 
      basis functions for local corrections
    * Broad support for 3D image file formats (using ITK), 
      including DICOM, Nifti, NRRD, MetaImage, and Analyze
    * DICOM and DICOM-RT import and export
    * XiO import and export
    * Plugin to 3D Slicer
 Plastimatch also features two handy utilities which are 
 not directly related to image registration:
    * FDK cone-beam CT reconstruction (GPU and multicore 
      accelerated)
    * Digitally reconstructed radiograph (DRR) generation 
      (GPU and multicore accelerated)
