=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg[0-9]// \
http://forge.abcd.harvard.edu/gf/project/plastimatch/frs/ \
    .*/plastimatch-(.+)-Source.tar.bz2
